package CalcRules;

import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.LinkedList;

import javax.swing.InputVerifier;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.UIManager;
import javax.swing.border.TitledBorder;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;

public class ActionRulesUI extends JPanel {
	private JTextField textSupport,textConfidence,FromVal, ToValue,txtIndices;
	private JFileChooser fileChooser, fileChooser1;
	private JLabel lblDataFileSelection, lblAttrFileSelection;
	private String[] allAttributes;
	private String[] allAttributes1;
	//private String[] allAttributesExceptDecision;
	//private LinkedList<String> totalData; 
	private JComboBox cboDecisionAttr;
	private JList list_1;JScrollPane scrollpane;JButton btnSubmit;
	InputVerifier verifier = new MyNumericVerifier();
	/**
	 * Create the panel.
	 */
	public ActionRulesUI() {
		fileChooser = new JFileChooser();
		fileChooser1 = new JFileChooser();
		list_1 = new JList<String>();
		setLayout(new FlowLayout(FlowLayout.LEFT, 5, 5));
		
		JPanel panel = new JPanel();
		add(panel);
		panel.setBorder(new TitledBorder(UIManager.getBorder("TitledBorder.border"), "Input Data", TitledBorder.LEADING, TitledBorder.TOP, null, new Color(0, 0, 0)));
		panel.setLayout(new GridLayout(0, 2, 5, 5));
		JLabel lblAttribute = new JLabel("Attribute");
		panel.add(lblAttribute);
		//ImageIcon ic2 = new ImageIcon(getClass().getResource("/button_browse.jpg"));
		JButton btnBrowse = new JButton("Browse...");//new javax.swing.ImageIcon(getClass.getResource("button_browse.jpg")));
		//btnBrowse.setIcon(ic2);

				//btnBrowse.setIcon(new javax.swing.ImageIcon(getClass().getResource("button_browse.jpg")));
		panel.add(btnBrowse);
		
		JLabel lblData = new JLabel("Data");
		panel.add(lblData);
		
		JButton btnDataBrowse = new JButton("Browse...");
		panel.add(btnDataBrowse);
		
		JLabel lblSupport = new JLabel("Support");
		panel.add(lblSupport);
		
		textSupport = new JTextField();
		panel.add(textSupport);
		textSupport.setColumns(10);
		
		JLabel lblConfidence = new JLabel("Confidence");
		panel.add(lblConfidence);
		
		textConfidence = new JTextField();
		panel.add(textConfidence);
		textConfidence.setColumns(10);
		//ImageIcon ic = new ImageIcon("/button_load.png");
		JButton btnLoad = new JButton("Load Data");
		//ImageIcon ic = new ImageIcon("/button_load.png");
		//btnLoad.setIcon(new javax.swing.ImageIcon(getCodeBase().getPath() + "button_load.png"));
		panel.add(btnLoad);
		
		JPanel panel_5 = new JPanel();
		panel_5.setBorder(new TitledBorder(UIManager.getBorder("TitledBorder.border"), "Selected Files", TitledBorder.LEADING, TitledBorder.TOP, null, new Color(0, 0, 0)));
		add(panel_5);
		panel_5.setLayout(new GridLayout(0, 1, 40, 10));
		
		JLabel lblAttributeFile = new JLabel("Attribute File:");
		panel_5.add(lblAttributeFile);
		
		lblAttrFileSelection = new JLabel("-");
		panel_5.add(lblAttrFileSelection);
		
		JLabel lblDataFile = new JLabel("Data File:");
		panel_5.add(lblDataFile);
		
		lblDataFileSelection = new JLabel("-");
		panel_5.add(lblDataFileSelection);
		
		JPanel panel_1 = new JPanel();
		add(panel_1);
		panel_1.setBorder(new TitledBorder(null, "Decision Attribute Information", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel_1.setLayout(new GridLayout(3, 2, 5, 5));
		
		JLabel lblDecisionAttribute = new JLabel("Decision Attribute");
		panel_1.add(lblDecisionAttribute);
		
	    cboDecisionAttr = new JComboBox();
		panel_1.add(cboDecisionAttr);
		
		JLabel lblDecisionValueFrom = new JLabel("Decision Value From");
		panel_1.add(lblDecisionValueFrom);
		
		FromVal = new JTextField();
		panel_1.add(FromVal);
		FromVal.setColumns(10);
		
		JLabel lblDecisionValueTo = new JLabel("Decision Value To");
		panel_1.add(lblDecisionValueTo);
		
		ToValue = new JTextField();
		panel_1.add(ToValue);
		ToValue.setColumns(10);
		
		JPanel panel_2 = new JPanel();
		add(panel_2);
		panel_2.setBorder(new TitledBorder(null, "Stable Attribute Information", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel_2.setLayout(new BoxLayout(panel_2, BoxLayout.Y_AXIS));
		
		JPanel panel_3 = new JPanel();
		panel_2.add(panel_3);
		panel_3.setLayout(new GridLayout(0, 2, 0, 0));
		
		JLabel lblStableAttributes = new JLabel("Stable Attributes");
		panel_3.add(lblStableAttributes);
		
		scrollpane = new JScrollPane();
		panel_3.add(scrollpane);
		
		JPanel panel_4 = new JPanel();
		panel_2.add(panel_4);
		panel_4.setLayout(new GridLayout(1, 2, 0, 0));
		
		JLabel lblIndices = new JLabel("Indices");
		panel_4.add(lblIndices);
		
		txtIndices = new JTextField();
		panel_4.add(txtIndices);
		txtIndices.setColumns(10);
		
	    btnSubmit = new JButton("Calculate");
		add(btnSubmit);

		
		//Listeners
		btnSubmit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                try {
                    submitActionPerformed(evt);
                } catch (IOException e) {

                    e.printStackTrace();
                }
            }
        });
		
		FromVal.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                decisionValueFromActionPerformed(evt);
            }
        });

        ToValue.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                decisionValueToActionPerformed(evt);
            }
        });
        
        btnBrowse.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                filePathActionPerformed(evt);
            }

        });

        btnDataBrowse.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                filePathActionPerformed1(evt);
            }
        });

        
        btnLoad.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                try {
                    dataLoadActionPerformed(evt);
                } catch (IOException e) {

                    e.printStackTrace();
                }
            }
        });
        
	}
	

	  protected void filePathActionPerformed1(ActionEvent evt) {
		// TODO Auto-generated method stub
		  int returnVal = fileChooser1.showOpenDialog(this);
	        if(returnVal == JFileChooser.APPROVE_OPTION){
	            lblDataFileSelection.setText(fileChooser1.getSelectedFile().getPath());
	        }
	}

	  private void decisionValueFromActionPerformed(java.awt.event.ActionEvent evt) {
	        // TODO add your handling code here:
		  InputVerifier verifier = new MyNumericVerifier();
		  FromVal.setInputVerifier(verifier);
	    }

	    private void decisionValueToActionPerformed(java.awt.event.ActionEvent evt) {
	        // TODO add your handling code here:
	    	InputVerifier verifier = new MyNumericVerifier();
			ToValue.setInputVerifier(verifier);
	    }


	    @SuppressWarnings({ "unchecked", "rawtypes" })
		private void dataLoadActionPerformed(java.awt.event.ActionEvent evt) throws IOException {
	        // TODO add your handling code here:
	        InputVerifier verifier = new MyNumericVerifier();
	        textSupport.setInputVerifier(verifier);
	        InputVerifier verifier1 = new MyNumericVerifier();
	        textConfidence.setInputVerifier(verifier1);
	        
	        
	        String fileName = lblAttrFileSelection.getText();
	        String line = null;
	        
	        if(fileName.isEmpty() || fileName.equalsIgnoreCase("-"))
	        {
	        	return;
	        }
	        if(lblDataFileSelection.getText().isEmpty() || lblAttrFileSelection.getText().equalsIgnoreCase("-"))
	        {
	        	return;
	        }
	        if(textSupport.getText().isEmpty())
	        {
	        	return;
	        }
	        if(textConfidence.getText().isEmpty())
	        {
	        	return;
	        }
	        
	        FileReader fileReader = new FileReader(fileName);
	        BufferedReader bufferedReader = new BufferedReader(fileReader);
	        while((line = bufferedReader.readLine()) != null) {
	            allAttributes = line.split("\\s+");
	            allAttributes1 = line.split("\\s+");
	        }
	        for(int i =0; i<allAttributes.length;i++){
	            allAttributes[i] = Integer.toString(i).concat("-").concat(allAttributes[i]);
	        }
	        bufferedReader.close();
	        list_1.setModel(new javax.swing.AbstractListModel() {
	            public int getSize() { return allAttributes.length; }
	            public Object getElementAt(int i) { return allAttributes[i]; }
	        });
	        scrollpane.setViewportView(list_1);
	        cboDecisionAttr.setModel(new javax.swing.DefaultComboBoxModel(allAttributes));
	    }
	    

		private void filePathActionPerformed(ActionEvent evt) {
			// TODO Auto-generated method stub
			int returnVal = fileChooser.showOpenDialog(this);
	        if(returnVal == JFileChooser.APPROVE_OPTION){
	            lblAttrFileSelection.setText(fileChooser.getSelectedFile().getPath());
	        }
		}

		  public class MyNumericVerifier extends InputVerifier {
		        @Override
		        public boolean verify(JComponent input) {
		            String text = null;

		            if (input instanceof JTextField) {
		                text = ((JTextField) input).getText();
		            }

		            try {
		                Integer.parseInt(text);
		            } catch (NumberFormatException e) {
		                JOptionPane.showMessageDialog(null, "Invalid data");
		                return false;
		            }

		            return true;
		        }

		        @Override
		        public boolean shouldYieldFocus(JComponent input) {
		            boolean valid = verify(input);
		            if (!valid) {
		                JOptionPane.showMessageDialog(null, "Invalid data");
		            }

		            return valid;
		        }
		    }
		  
		    private void submitActionPerformed(java.awt.event.ActionEvent evt) throws IOException {
		        // Indices of Stable Attributes
		        int i = 0;

		        int[] stableAttributes;
		        if(txtIndices.getText().toString().length()!=0){
		            String[] stableAttributeIndices = txtIndices.getText().toString().split(",");
		            stableAttributes = new int[stableAttributeIndices.length];
		            for (String attributeIndex:stableAttributeIndices) {
		                stableAttributes[i] = Integer.parseInt(attributeIndex);
		                i++;
		            }
		        }
		        else{
		            stableAttributes = new int[0];
		        }

		        ActionRules.SetAttributeNames(allAttributes1);
		        ActionRules.SetDataFilePath(lblDataFileSelection.getText().toString());
		        ActionRules.SetSupportThreshold(Integer.parseInt(textSupport.getText().toString()));
		        ActionRules.SetConfidenceThreshold(Integer.parseInt(textConfidence.getText().toString()));
		        ActionRules.SetDecisionAttribute(cboDecisionAttr.getSelectedItem().toString().split("-")[1]);
		        ActionRules.SetDecisionFromValue(FromVal.getText().toString());
		        ActionRules.SetDecisionToValue(ToValue.getText().toString());
		        ActionRules.SetStableAttribute(stableAttributes);

		        ActionRules.aras();

		    }
}
